DEBUG con 1
DEBUG_OUT con 1
XBEEONHSERIAL con 1
;==============================================================================
;Description: Simple Test program that tries to test some of the XBEE and HSerial
;			stuff...
;
;KNOWN BUGS: 
;   - Probably Alot ;) 
;==============================================================================
USEHSPSerIAL con 1
DEBUG_WITH_LEDS con 1
fPacketChanged		var bit			; Something change in the packet
bPacketPrev			var	byte(10)	;XP: 8 ->10
fPrevPacketValid	var	bit
i					var	byte

atmy				var	word
atdh				var	long
atdl				var	long
atvr				var	long
atsh				var	long
atsl				var	long
atni				var byte(21)
cbRead				var	byte


wXbeeDL	var	word

	enable
	gosub InitTimer				; Initialize our timer (Timer A)
	gosub InitXBee
	high	p4
	high	p5
	high	p6

;	hservo [p0\0, p1\0]
	pause 1000
	Sound P9,[100\4400]

	; Now try seeing what information we can retrieve.
	; now lets get the data to send back
	gosub GetXBeeHexVal["S","H",0x1], atsh		; get the serial high, enter command, don't exit
	gosub GetXBeeHexVal["S","L",0x0], atsl		; get the serial low, don't enter or leave
	gosub GetXBeeHexVal["M","Y",0x0], atmy		; get My value
	gosub GetXBeeHexVal["D","L",0x0], atdl		; get destination address
	gosub GetXBeeHexVal["D","H",0x0], atdh		; get
	gosub GetXBeeHexVal["V","R",0x0], atvr		; get the version number
	
	gosub GetXBeeStringVal["N","I", 0x02, @atni, 21], cbRead ; 
	
	; Now lets output this to the debug terminal
	serout s_out, i9600, [13,13, "******** XBee Test Program ********", 13, |
		"MY: ", hex atmy, 13, |
		"SH/L: ", hex atsh, " ", hex atsl, 13, |
		"Dest: ", hex atdh, " ", hex atdl, 13, |
		"NI: ", str atni\21\13, 13, |
		"Ver: ", hex atvr, 13]

	
'	gosub GetXBeeDL[],wXbeeDL
'	serout s_out, i9600, ["Get XBee Dest ", hex wXbeeDL, 13]

	pause 50

main:
	gosub ReceiveXBeePacket
	; See if we have a valid packet to process
	if fPacketValid  then
		fPacketChanged = 0	; don't need to worry about slop 
		for i = 0 to 9		;XP 7->9
			if (bPacket(i) <> bPacketPrev(i)) then
				fPacketChanged = 1
				bPacketPrev(i) = bPacket(i)
			endif
		next
		
		if fPacketChanged  then
			if fPacketForced then
				gosub SendXbeeNewDataOnlyPacket[1]
			endif
			serout s_out, i9600, [bin8 bPacket(PKT_BTNHI)\8, bin8 bPacket(PKT_BTNLOW)\8, " "] 
			for i = 2 to 9 ;XP 7->9
				serout s_out, i9600, [dec bPacket(i)," "]
			next
			serout s_out, i9600,[13] 

		endif
	else
		if fPrevPacketValid then
			serout s_out, i9600, ["Invalid Packet", 13]
		endif
	endif
	fPrevPacketValid = fPacketValid
	goto main
